#Импортируем необходимые библиотеки
from gpiozero import LED, Button, MotionSensor
import smtplib
from email.mime.text import MIMEText
from signal import pause

#Создайте объекты для работы с обоими светодиодами, кнопкой и PIR-датчиком
led_triggered = LED(18)
button = Button(2)
pir = MotionSensor(4)

#Управляющие переменные
motion_sensor_status = False
email_sent = False

#Включение или выключение PIR-датчика
def arm_motion_sensor():
    global email_sent
    global motion_sensor_status
    if motion_sensor_status == True:
        motion_sensor_status = False
        led_status.off()
        led_triggered.off()
    else:
        motion_sensor_status = True
        email_sent = False
        led_status.on()

#Отправка электронного письма, когда PIR-датчик обнаружил движение
def send_email():
    global email_sent
    global motion_sensor_status
    if(motion_sensor_status == True and email_sent == False):
        #Замените настройки в следующих трех строках на свои
        from_email_addr = 'ВАШ_АДРЕС@gmail.com'
        from_email_password = 'ВАШ_ПАРОЛЬ'
        to_email_addr = 'ВАШ_ВТОРОЙ_АДРЕС@gmail.com'

        #Заполнение тела сообщения
        body = 'В вашей комнате было обнаружено движение.'
        msg = MIMEText(body)

        #Указание отправителя и получателя
        msg['From'] = from_email_addr
        msg['To'] = to_email_addr

        #Установка темы письма
        msg['Subject'] = 'ОХРАННАЯ СИГНАЛИЗАЦИЯ'

        #Подключение к серверу и отправка письма
        #В строке ниже замените настройки на SMTP-сервер вашего провайдера
        server = smtplib.SMTP('smtp.gmail.com', 587)
        #Закомментируйте следующую строку, если ваш провайдер не использует TLS
        server.starttls()
        server.login(from_email_addr, from_email_password)
        server.sendmail(from_email_addr, to_email_addr, msg.as_string())
        server.quit()
        email_sent = True
        led_triggered.on()
        print('Письмо отправлено')

#Указание, какую функцию вызовет нажатие кнопки
button.when_pressed = arm_motion_sensor
#Указание, какая функция запускается при обнаружении движения
pir.when_motion = send_email

pause()
