#на основе классического примера использования библиотеки Тони ДиКола NeoPixel

#подключаем необходимые библиотеки
from neopixel import *
from time import sleep
from gpiozero import Button, MCP3008

# настраиваем светодиодную ленту
LED_COUNT = 14 #количество светодиодов в ленте
LED_PIN = 18 #порт GPIO, к которому подключается лента(должен поддерживать ШИМ!)
LED_FREQ_HZ = 800000 #частота светодиодов в герцах (обычно 800 кГц)
LED_DMA = 5 #канал DMA для генерирования сигнала (попробуем 5)
LED_INVERT = False #задайте True если нужно инвертировать сигнал

#создаем объекты pot для обращения к каналам 0 и 1 микросхемы MCP3008
pot_brightness = MCP3008(0)
pot_speed = MCP3008(1)

#объявляем переменную для управления кнопкой и ставим ее в соответствие GPIO 2
button_start = Button(2)

#объявляем переменную для управления анимацией
running_animation = False

#генерируем цвета радуги в диапазоне 0—255 градаций
def wheel(pos):
    if pos < 85:
        return Color(pos * 3, 255 - pos * 3, 0)
    elif pos < 170:
        pos -= 85
        return Color(255 - pos * 3, 0, pos * 3)
    else:
        pos -= 170
        return Color(0, pos * 3, 255 - pos * 3)

#рисуем радугу, которая равномерно распределяется по всем пикселям
def rainbowCycle(strip):
    for j in range(256):
        for i in range(strip.numPixels()):
            strip.setPixelColor(i, wheel((int(i * 256 / strip.numPixels()) + j) & 255))
        strip.show()
        sleep((pot_speed.value*40)/1000.0)

#функция для запуска и остановки анимации
def start_animation():
    global running_animation
    if running_animation == True:
        running_animation = False
    else:
        running_animation = True

#вызов функции, которая выполняется при нажатии кнопки
button_start.when_pressed = start_animation

#создаем объект NeoPixel с заданными настройками
strip = Adafruit_NeoPixel(LED_COUNT, LED_PIN, LED_FREQ_HZ, LED_DMA, LED_INVERT, int(pot_brightness.value*255))

#объявляем ленту
strip.begin()
while True:
    if running_animation == True:
        #задаем яркость светодиодной ленты
        strip.setBrightness(int(pot_brightness.value*255))
        rainbowCycle(strip)
