import Adafruit_CharLCD as LCD
import time

#конфигурация портов Raspberry Pi
lcd_rs = 27
lcd_en = 22
lcd_d4 = 25
lcd_d5 = 24
lcd_d6 = 23
lcd_d7 = 18
lcd_backlight = 4

#определение размеров ЖК-дисплея
lcd_columns = 16
lcd_rows = 2

#инициализация ЖК-дисплея
lcd = LCD.Adafruit_CharLCD(lcd_rs, lcd_en, lcd_d4, lcd_d5,
            lcd_d6, lcd_d7, lcd_columns, lcd_rows, lcd_backlight)

#ввод вашего сообщения
title = "Не забыть!"
reminder = "У вас назначен визит к врачу в следующий понедельник"

#установка задержки прокрутки
delay = 0.3

#write a function to scroll the message
def scroll_text(reminder, delay):
    padding = " " * lcd_columns
    scroll_message = padding + reminder + " "
    for i in range(len(scroll_message)):
        lcd.set_cursor(0, 1)
        lcd.message(scroll_message[i:(i+lcd_columns)])
        time.sleep(delay)

#прокрутка сообщения в бесконечном цикле
lcd.clear()
lcd.home()
lcd.message(title)

while(True):
    scroll_text(reminder, delay)
