#основан на примере для Sense HAT Pong с сайта raspberrypi.org

#импорт необходимых библиотек
from random import randint
from time import sleep

#используйте эту строку, если у вас установлена плата Sense HAT
from sense_hat import SenseHat

#раскомментируйте следующую строку, если у вас эмулятор
#from sense_emu import SenseHat

#создание объекта с именем sense
sense = SenseHat()

#задание позиции ракетки, случайной позиции мяча и его скорости
y = 4
ball_position = [int(randint(2,6)), int(randint(1,6))]
ball_velocity = [1, 1]

#красный цвет
X = [255, 0, 0]
#нет цвета
N = [0, 0, 0]

#массив грустного лица
sad_face = [
N, N, X, X, X, X, N, N,
N, X, N, N, N, N, X, N,
X, N, X, N, N, X, N, X,
X, N, N, X, N, N, N, X,
X, N, N, X, N, N, N, X,
X, N, X, N, N, X, N, X,
N, X, N, N, N, N, X, N,
N, N, X, X, X, X, N, N
]

#отрисовка ракетки на позиции y
def draw_bat():
    sense.set_pixel(0, y, 0, 255, 0)
    sense.set_pixel(0, y+1, 0, 255, 0)
    sense.set_pixel(0, y-1, 0, 255, 0)

#перемещение ракетки вверх
def move_up(event):
    global y
    if y > 1 and event.action=='pressed':
        y -= 1

#перемещение ракетки вниз
def move_down(event):
    global y
    if y < 6 and event.action=='pressed':
        y += 1

#перемещение мяча на следующую позицию
def draw_ball():
    #отображение мяча на текущей позиции
    sense.set_pixel(ball_position[0], ball_position[1], 75, 0, 255)
    #следующая позиция мяча
    ball_position[0] += ball_velocity[0]
    ball_position[1] += ball_velocity[1]
    #расчет следующей позиции, если мяч касается потолка
    if ball_position[0] == 7:
        ball_velocity[0] = -ball_velocity[0]
    #расчет следующей позиции, если мяч касается стены
    if ball_position[1] == 0 or ball_position[1] == 7:
        ball_velocity[1] = -ball_velocity[1]
    #если мяч достиг позиции 0, то игрок проиграл и игра заканчивается
    if ball_position[0] == 0:
        sleep(0.25)
        sense.set_pixels(sad_face)
        quit()
    #расчет следующей позиции, если мяч отбивается ракеткой
    if ball_position[0] == 1 and y - 1 <= ball_position[1] <= y+1:
        ball_velocity[0] = -ball_velocity[0]

#установка соответствующих функций на движение джойстика вверх и вниз
sense.stick.direction_up = move_up
sense.stick.direction_down = move_down

#запуск игры
while True:
    sense.clear()
    draw_bat()
    draw_ball()
    sleep(0.25)
